/*
		MobQuery.cpp : implementation file

        Copyright (C) 2000 Patrick Dughi

        This software may be used and distributed according to the terms
        of the GNU Public License, incorporated herein by reference, located
		as the file gpl.txt in this same directory.

        The author may be reached at dughi@imaxx.net.

.		Class to match dialog of the same name.
	
*/


#include "stdafx.h"
#include "Cbreak.h"
#include "MobQuery.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// MobQuery dialog


MobQuery::MobQuery(int def, CWnd* pParent /*=NULL*/)
	: CDialog(MobQuery::IDD, pParent)
{
	//{{AFX_DATA_INIT(MobQuery)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	value = def;
}


void MobQuery::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(MobQuery)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(MobQuery, CDialog)
	//{{AFX_MSG_MAP(MobQuery)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// MobQuery message handlers

BOOL MobQuery::OnInitDialog() 
{
	CDialog::OnInitDialog();
	map<int,Mob>::const_iterator oi;
    extern World the_world;

  if(!the_world.mob_list.empty()) {
    for(oi = the_world.mob_list.begin();oi != the_world.mob_list.end();oi++) {
	   ((CComboBox *) GetDlgItem(IDC_QUERY_MOBLIST))->AddString(
				iprintf("%d - %s ",oi->first,oi->second.sdesc.c_str()));
		}
		oi=the_world.mob_list.begin();
	  ((CComboBox *) GetDlgItem(IDC_QUERY_MOBLIST))->SelectString(-1,
			iprintf("%d - %s ",oi->first, oi->second.sdesc.c_str()));
	}
 
  if(!the_world.mob_list.size()) {
		GetDlgItem(IDC_QUERY_MOBLIST)->EnableWindow(FALSE);
  } else {
		GetDlgItem(IDC_QUERY_MOBLIST)->EnableWindow(TRUE);
  }
	
	return TRUE; 
}

void MobQuery::OnOK() 
{
	int count;
  char buf[512];
  char *p;
	count=((CComboBox *) GetDlgItem(IDC_QUERY_MOBLIST))->GetCurSel();
	((CComboBox *) GetDlgItem(IDC_QUERY_MOBLIST))->GetLBText(count,buf);
  p=strchr(buf,' ');
	*p='\0';
	value = atoi(buf);

	CDialog::OnOK();
}
